﻿package
{
	
 	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.utils.setInterval;
	import flash.filters.GlowFilter;
	import flash.filters.BlurFilter;
	import flash.display.*;
	import flash.geom.*;
	
	public class Genever extends Sprite
	{
		private var points:Array = new Array();
		private var numPoints:Number = 200;
		private var gravity:Number = 0.1;
		private var i:Number;
		private var centerX:Number;
		private var centerY:Number;
		private var theta:Number=0;
		private var fillType:String = GradientType.RADIAL;
		private var colors:Array = [0x000000,0x009C58];
		private var alphas:Array = [1,0.3];
		private var ratios:Array = [100, 255];
		
		
		public function Genever()
		{
			addEventListener(Event.ADDED_TO_STAGE,addedHandler);
			
		}
		
		
		
		private function addedHandler(e:Event):void
		{
			stage.addEventListener(MouseEvent.CLICK,clickHandler);
		}
		private function clickHandler(e:MouseEvent):void
		{
			centerX = e.stageX;
			centerY = e.stageY;
			theta= Math.random()*360;
			colors = [0x000000,Math.random()*0xFFFFFF]

			addEventListener(Event.ENTER_FRAME,enterHandler);
		}
		
		
		
		private function enterHandler(e:Event):void
		{
			addPoint();
			update();
			draw();
			
			
		}
		private function addPoint():void
		{
			var point:Object;
			if(points.length<numPoints){
			point = {};
			initPoint(point);
			points.push(point);
			}
		}
		private function initPoint(p:Object):void
		{
			p.x = mouseX;
			p.y = stage.stageHeight;
			p.vx = 0.2;
			p.vy = -6-5;
			p.radius = 5+1;
			
		}
		private function update():void
		{
			for(var i:Number = 0;i< points.length;i++){
				points[i].vy += gravity;
				points[i].x += points[i].vx;
				points[i].y+= points[i].vy;
				if(points[i].x>stage.stageWidth  || points[i].x < 0 || points[i].y >stage.stageHeight || points[i].y < 0){
					initPoint(points[i]);
				}
			}
		}
		private function draw():void
		{
				
			this.graphics.clear();
			for(var i:Number = 0;i<points.length;i++){
				this.graphics.beginGradientFill(fillType,colors,alphas,ratios);
				this.graphics.drawRoundRect(points[i].x,points[i].y,points[i].radius*30,9,10);
				this.graphics.endFill();
				//this.graphics.lineGradientStyle(fillType,colors,alphas,ratios);
				this.graphics.lineStyle(0.2,0xf9f9f9);
				this.graphics.lineTo(mouseX,mouseY);
			}
		}
	}
}